
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Discovery_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const discovery_items = await db.discovery_items.create(
            {
                id: data.id || undefined,
        
        item_type: data.item_type
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        subtitle: data.subtitle
        ||
        null
            ,
            
        score: data.score
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        published_at: data.published_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await discovery_items.setCreator( data.creator || null, {
            transaction,
        });
        
        await discovery_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.discovery_items.getTableName(),
                belongsToColumn: 'thumbnail_images',
                belongsToId: discovery_items.id,
            },
            data.thumbnail_images,
            options,
        );
        

        return discovery_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const discovery_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                item_type: item.item_type
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                subtitle: item.subtitle
            ||
            null
            ,
            
                score: item.score
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                published_at: item.published_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const discovery_items = await db.discovery_items.bulkCreate(discovery_itemsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < discovery_items.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.discovery_items.getTableName(),
                    belongsToColumn: 'thumbnail_images',
                    belongsToId: discovery_items[i].id,
                },
                data[i].thumbnail_images,
                options,
            );
        }
        

        return discovery_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const discovery_items = await db.discovery_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.item_type !== undefined) updatePayload.item_type = data.item_type;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.subtitle !== undefined) updatePayload.subtitle = data.subtitle;
        
        
        if (data.score !== undefined) updatePayload.score = data.score;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.published_at !== undefined) updatePayload.published_at = data.published_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await discovery_items.update(updatePayload, {transaction});

        
        
        if (data.creator !== undefined) {
            await discovery_items.setCreator(
              
              data.creator,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await discovery_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.discovery_items.getTableName(),
                belongsToColumn: 'thumbnail_images',
                belongsToId: discovery_items.id,
            },
            data.thumbnail_images,
            options,
        );
        

        return discovery_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const discovery_items = await db.discovery_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of discovery_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of discovery_items) {
                await record.destroy({transaction});
            }
        });


        return discovery_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const discovery_items = await db.discovery_items.findByPk(id, options);

        await discovery_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await discovery_items.destroy({
            transaction
        });

        return discovery_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const discovery_items = await db.discovery_items.findOne(
            { where },
            { transaction },
        );

        if (!discovery_items) {
            return discovery_items;
        }

        const output = discovery_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.creator = await discovery_items.getCreator({
            transaction
        });
        
        
        output.thumbnail_images = await discovery_items.getThumbnail_images({
            transaction
        });
        
        
        output.organizations = await discovery_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.creator_profiles,
        as: 'creator',
        
        where: filter.creator ? {
          [Op.or]: [
            { id: { [Op.in]: filter.creator.split('|').map(term => Utils.uuid(term)) } },
            {
              handle: {
                [Op.or]: filter.creator.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'thumbnail_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'discovery_items',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.subtitle) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'discovery_items',
                        'subtitle',
                        filter.subtitle,
                    ),
                };
            }
            

            
            

            
            if (filter.scoreRange) {
                const [start, end] = filter.scoreRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    score: {
                    ...where.score,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    score: {
                    ...where.score,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.published_atRange) {
                const [start, end] = filter.published_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.item_type) {
                where = {
                    ...where,
                item_type: filter.item_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.discovery_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'discovery_items',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.discovery_items.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

